function unsubscribeAndSubscribe(path, id, reason) {
    var addSuccess = false;
    CARBON.showConfirmationDialog(reason, function() {

            new Ajax.Request('../info/subscription-ajaxprocessor.jsp', {
            method: 'post',
            parameters: {path: path, id: id},
            onSuccess: function(transport) {
                if (!transport) {return;}
                subscribe();
            },
            onFailure: function() {

            }
        });
    }, null);
    return addSuccess;
}

function unsubscribe(path, id) {
    CARBON.showConfirmationDialog(org_wso2_carbon_governance_notifications_ui_jsi18n["are.you.sure.you.want.to.unsubscribe"], function() {
        var addSuccess = true;
            new Ajax.Request('../info/subscription-ajaxprocessor.jsp', {
            method: 'post',
            parameters: {path: path, id: id},
            onSuccess: function(transport) {
                if (!transport) {return;}
                window.location = "../notifications/notifications.jsp?region=region3&item=governance_notification_menu";
            },
            onFailure: function() {
                addSuccess = false;
            }
        });
    }, null);
}

function subscribe() {
    var path = $('subscriptionPath').value;
    var endpoint = "";
    var reason = "";
    if ($('subscriptionDataEmail').style.display == "") {
        reason += validateEmail($('subscriptionInput'));
        endpoint += "mailto:" + $('subscriptionInput').value;
    } else if ($('subscriptionDataUserProfile').style.display == "") {
        reason += validateEmpty($('subscriptionInput'), org_wso2_carbon_governance_notifications_ui_jsi18n["user.name"]);
        if (reason == "") {
            var username = $('subscriptionUserProfile').value;
            if (username != "" && username != $('subscriptionInput').value) {
                reason = org_wso2_carbon_governance_notifications_ui_jsi18n["you.are.only.allowed.to.subscribe.to.your.profile"];
            }
        }
        if (reason == "") {
            reason += validateUserExists($('subscriptionInput').value);
        }
        endpoint += "user://" + $('subscriptionInput').value;
    } else {
        reason += validateUrl($('subscriptionInput'), org_wso2_carbon_governance_notifications_ui_jsi18n["web.service.url"]);
        endpoint += $('subscriptionInput').value;
    }
    if (reason == "") {
        var eventName = $('eventList').value;
        var notification = $('notificationMethodList').value;
        switch (notification) {
            case "2":
                var doRest = true;
                new Ajax.Request('../info/subscription-ajaxprocessor.jsp', {
                    method: 'post',
                    parameters: {path: path, endpoint: endpoint, eventName: eventName, doRest: doRest},
                    onSuccess: function(transport) {
                        if (!transport) {return;}
                        window.location = "../notifications/notifications.jsp?region=region3&item=governance_notification_menu";
                    },
                    onFailure: function(transport) {
                        showRegistryError(transport.responseText);
                    }
                });
                break;
            default:
                new Ajax.Request('../info/subscription-ajaxprocessor.jsp', {
                    method: 'post',
                    parameters: {path: path, endpoint: endpoint, eventName: eventName},
                    onSuccess: function(transport) {
                        if (!transport) {return;}
                        window.location = "../notifications/notifications.jsp?region=region3&item=governance_notification_menu";
                    },
                    onFailure: function(transport) {
                        showRegistryError(transport.responseText);
                    }
                });
                break;
        }
    } else {
        CARBON.showWarningDialog(reason);
    }
}

var sub_path;

function updateSubscriber() {
    if (!$('subscriptionPath') || sub_path == $('subscriptionPath').value) {
        return;
    }
    sub_path = $('subscriptionPath').value;
    var path = sub_path;
    new Ajax.Request('../notifications/registrysubscription-ajaxprocessor.jsp', {
        method: 'post',
        parameters: {path: path},
        onSuccess: function(transport) {
            $('subscription-area-div').innerHTML = transport.responseText;
        },
        onFailure: function(transport) {
            showRegistryError(transport.responseText);
        }
    });
}

function cancelAddSubscription() {
    window.location = "../notifications/notifications.jsp?region=region3&item=governance_notification_menu";
}

function changeVisibility() {
    var visible = $('eventList').value;
    switch (visible) {
        case "0":
            $('notificationMethodList').disabled = true;
            visible = "0";
            break;
        default:
            $('notificationMethodList').disabled = false;
            visible = $('notificationMethodList').value;
            break;
    }
    resetInputVisibility();
    switch (visible) {
        case "1":
            $('subscriptionDataInputRecord').style.display = "";
            $('subscriptionDataEmail').style.display = "";
            $('subscribeButton').disabled = false;
            break;
        case "2":
        case "3":
            $('subscriptionDataInputRecord').style.display = "";
            $('subscriptionDataHTMLSOAP').style.display = "";
            $('subscribeButton').disabled = false;
            break;
        case "4":
            $('subscriptionDataInputRecord').style.display = "";
            $('subscriptionDataUserProfile').style.display = "";
            $('subscribeButton').disabled = false;
            break;
    }

}

function resetInputVisibility() {
    $('subscribeButton').disabled = true;
    $('subscriptionInput').value = "";
    $('subscriptionInput').style.background = 'White';
    $('subscriptionDataInputRecord').style.display = "none";
    $('subscriptionDataEmail').style.display = "none";
    $('subscriptionDataHTMLSOAP').style.display = "none";
    $('subscriptionDataUserProfile').style.display = "none";
}

function validateUserExists(username) {
    var error = "";
    new Ajax.Request('../info/is_user_valid-ajaxprocessor.jsp',
        {
            method:'post',
            parameters: {username: username},
            asynchronous:false,
            onSuccess: function(transport) {
                var returnValue = transport.responseText;
                if (returnValue.search(/----UserExists----/) == -1){
                    error = org_wso2_carbon_governance_notifications_ui_jsi18n["no.valid.user.exists"] + " <strong>" + username + "</strong>.";
                }
            },
            onFailure: function() {

            }
        });
    return error;
}
